<?php
/* Es fan les consultes a la base de dades per obtenir les dades dels jaciments. */
/* Es poden fer 2 tipus de consultes: o b obtenir les dades de tots els         */
/* o b obtenir noms les del perode seleccionat.                               */

/* Funci per reemplaar carcters especials amb el seu codi HTML.               */
function parseToXML($htmlStr)
{
$xmlStr=str_replace('','&amp;agrave;',$htmlStr);
$xmlStr=str_replace('','&amp;Agrave;',$xmlStr);
$xmlStr=str_replace('','&amp;eacute;',$xmlStr);
$xmlStr=str_replace('','&amp;Eacute;',$xmlStr);
$xmlStr=str_replace('','&amp;egrave;',$xmlStr);
$xmlStr=str_replace('','&amp;Egrave;',$xmlStr);
$xmlStr=str_replace('','&amp;iacute;',$xmlStr);
$xmlStr=str_replace('','&amp;Iacute;',$xmlStr);
$xmlStr=str_replace('','&amp;oacute;',$xmlStr);
$xmlStr=str_replace('','&amp;Oacute;',$xmlStr);
$xmlStr=str_replace('','&amp;ograve;',$xmlStr);
$xmlStr=str_replace('','&amp;Ograve;',$xmlStr);
$xmlStr=str_replace('','&amp;uacute;',$xmlStr);
$xmlStr=str_replace('','&amp;Uacute;',$xmlStr);
$xmlStr=str_replace('','&amp;iuml;',$xmlStr);
$xmlStr=str_replace('','&amp;Iuml;',$xmlStr);
$xmlStr=str_replace('','&amp;uuml;',$xmlStr);
$xmlStr=str_replace('','&amp;Uuml;',$xmlStr);
$xmlStr=str_replace('','&amp;ccedil;',$xmlStr);
$xmlStr=str_replace('','&amp;Ccedil;',$xmlStr);
return $xmlStr;
}


/* Connexi amb la base de dades.                                                */
include ("conexio.php");

/* Obtenci del perode seleccionat.                                             */
$periode = $_GET['periode'];

/* Si el perode seleccionat s "Tots" s'obtenen les dades de tots els jaciments */
/* i a es van retornant en format XML a mesura que es van obtenint.              */
/* Els passos a seguir s'indiquen a continuaci i tamb es senyalen dins el codi:*/
/*   1- Es seleccionen tots els registres de la taula 'jaciments'.               */
/*   2- Per cada jaciment es seleccionen tots els identificadors dels perodes   */
/*      que es troben relacionats amb el jaciment a la taula 'jacimentsxperiode'.*/
/*   3- S'obtenen de la taula 'periodes' les dades dels perodes relacionats amb */
/*      cada jaciment mitjanant l'identificador del perode obtingut al pas 2.  */
/*      Els atributs 'periode' i 'epoca' es van acumulant separats per comes a   */
/*      les cadenes $periode i $epoca, respectivament. Sn aquestes cadenes les  */
/*      que es retornen.                                                         */
/*      Es fa aix perqu hi ha jaciments que tenen restes de ms d'un perode.  */
/*   4- S'actua de manera anloga al pas 3 per obtenir de la taula 'imatges' les */
/*      dades de les imatges per en aquest cas sense acumular-les, sin que es  */
/*      retornen una a una, afegint la informaci del perode a la descripci .  */
/*   5- S'actua de manera anloga al pas 4 per obtenir de la taula 'documents'   */
/*      les dades dels documents.                                                */
if($periode=="Tots"){

/*   1- Es seleccionen tots els registres de la taula 'jaciments'.               */
	$sql_jaciments=mysql_query("SELECT * FROM jaciments");
	header('Content-Type: text/xml');
	echo "<?xml version=\"1.0\" ?><llistatJaciments>";
	while($row_jaciments = mysql_fetch_array($sql_jaciments)) {
		echo "<jaciment><nom>".parseToXML($row_jaciments['nom'])."</nom><ubicacio>".parseToXML($row_jaciments['ubicacio'])."</ubicacio>
			<latitud>".$row_jaciments['latitud']."</latitud><longitud>".$row_jaciments['longitud']."</longitud>";

/*   2- Per cada jaciment es seleccionen tots els identificadors dels perodes   */
/*      que es troben relacionats amb el jaciment a la taula 'jacimentsxperiode'.*/	
		$sql_jacimentsxperiode = mysql_query("SELECT * FROM jacimentsxperiode WHERE id_jaciment=".$row_jaciments['id_jaciment']."");

/*   3- S'obtenen de la taula 'periodes' les dades dels perodes relacionats amb */
/*      cada jaciment mitjanant l'identificador del perode obtingut al pas 2.  */
/*      Els atributs 'periode' i 'epoca' es van acumulant separats per comes a   */
/*      les cadenes $periode i $epoca, respectivament. Sn aquestes cadenes les  */
/*      que es retornen.                                                         */
/*      Es fa aix perqu hi ha jaciments que tenen restes de ms d'un perode.  */
		$periode = "";
		$epoca = "";
		$i = 1;
		$j = mysql_num_rows($sql_jacimentsxperiode);
		while($row_jacimentsxperiode = mysql_fetch_array($sql_jacimentsxperiode)) {
			$sql_periodes = mysql_query("SELECT * FROM periodes WHERE id_periode=".$row_jacimentsxperiode['id_periode']."");
			$row_periodes = mysql_fetch_array($sql_periodes);
			if($i<$j){
				$periode = $periode.parseToXML($row_periodes['periode']).", ";
				$epoca = $epoca.parseToXML($row_periodes['epoca']).", ";
				$i++;
			}
			else {
				$periode = $periode.parseToXML($row_periodes['periode']);
				$epoca = $epoca.parseToXML($row_periodes['epoca']);
			}
			mysql_free_result($sql_periodes);
		}
		mysql_free_result($sql_jacimentsxperiode);
		echo "<periode>".$periode."</periode><epoca>".$epoca."</epoca><imatges>";

/*   4- S'actua de manera anloga al pas 3 per obtenir de la taula 'imatges' les */
/*      dades de les imatges per en aquest cas sense acumular-les, sin que es  */
/*      retornen una a una, afegint la informaci del perode a la descripci .  */
		$sql_jacimentsxperiode = mysql_query("SELECT * FROM jacimentsxperiode WHERE id_jaciment=".$row_jaciments['id_jaciment']."");
		while($row_jacimentsxperiode = mysql_fetch_array($sql_jacimentsxperiode)) {
			$sql_periodes = mysql_query("SELECT * FROM periodes WHERE id_periode=".$row_jacimentsxperiode['id_periode']."");
			$row_periodes = mysql_fetch_array($sql_periodes);
			$sql_imatges = mysql_query("SELECT * FROM imatges WHERE id_jaciment=".$row_jacimentsxperiode['id_jaciment']." AND id_periode=".$row_periodes['id_periode']."");
			while($row_imatges = mysql_fetch_array($sql_imatges)) {
				echo "<imatge>".parseToXML($row_imatges['imatge'])."</imatge><descripcio>".parseToXML($row_imatges['descripcio'])." (".parseToXML($row_periodes['periode']).")</descripcio>";
			}
			mysql_free_result($sql_imatges);
			mysql_free_result($sql_periodes);
		}
		mysql_free_result($sql_jacimentsxperiode);
		echo "</imatges><documents>";

/*   5- S'actua de manera anloga al pas 4 per obtenir de la taula 'documents'   */
/*      les dades dels documents.                                                */
		$sql_jacimentsxperiode = mysql_query("SELECT * FROM jacimentsxperiode WHERE id_jaciment=".$row_jaciments['id_jaciment']."");
		while($row_jacimentsxperiode = mysql_fetch_array($sql_jacimentsxperiode)) {
			$sql_periodes = mysql_query("SELECT * FROM periodes WHERE id_periode=".$row_jacimentsxperiode['id_periode']."");
			$row_periodes = mysql_fetch_array($sql_periodes);
			$sql_documents=mysql_query("SELECT * FROM documents WHERE id_jaciment=".$row_jacimentsxperiode['id_jaciment']." AND id_periode=".$row_periodes['id_periode']."");
			while($row_documents = mysql_fetch_array($sql_documents)) {
				echo "<document>".parseToXML($row_documents['document'])."</document><descripcio>".parseToXML($row_documents['descripcio'])." (".parseToXML($row_periodes['periode']).")</descripcio>";
			}
			mysql_free_result($sql_documents);

			mysql_free_result($sql_periodes);
		}
		mysql_free_result($sql_jacimentsxperiode);
		echo "</documents>";
		echo "</jaciment>";
	}
	echo "</llistatJaciments>";
	mysql_free_result($sql_jaciments);
} 


/* En cas contrari s'obtenen les dades de tots els jaciments del perode         */
/* seleccionat i a es van retornant en format XML a mesura que es van obtenint.  */
/* Els passos a seguir s'indiquen a continuaci:                                 */
/*   1- Es seleccionen tots els registres de la taula 'periodes'.                */
/*   2- Per cada perode es seleccionen tots els identificadors dels jaciments   */
/*      que es troben relacionats amb el perode a la taula 'jacimentsxperiode'. */
/*   3- S'obtenen de la taula 'jaciments' les dades dels jaciments relacionats   */
/*      amb el perode mitjanant l'identificador del jaciment obtingut al pas 2.*/
/*   4- S'actua de manera anloga al pas 3 per obtenir de la taula 'imatges' les */
/*      dades de les imatges.                                                    */
/*   5- S'actua de manera anloga al pas 4 per obtenir de la taula 'documents'   */
/*      les dades dels documents.                                                */
   else {
	$sql_periodes = mysql_query("SELECT * FROM periodes WHERE periode='".$periode."'");
	$row_periodes = mysql_fetch_array($sql_periodes);
	mysql_free_result($sql_periodes);
	$sql_jacimentsxperiode = mysql_query("SELECT * FROM jacimentsxperiode WHERE id_periode=".$row_periodes['id_periode']."");
	header('Content-Type: text/xml');
	echo "<?xml version=\"1.0\" ?><llistatJaciments>";
	while($row_jacimentsxperiode = mysql_fetch_array($sql_jacimentsxperiode)) {
		$sql_jaciments = mysql_query("SELECT * FROM jaciments WHERE id_jaciment=".$row_jacimentsxperiode['id_jaciment']."");
		$row_jaciments = mysql_fetch_array($sql_jaciments);
		mysql_free_result($sql_jaciments);
		echo "<jaciment><nom>".parseToXML($row_jaciments['nom'])."</nom><ubicacio>".parseToXML($row_jaciments['ubicacio'])."</ubicacio>
			<latitud>".$row_jaciments['latitud']."</latitud><longitud>".$row_jaciments['longitud']."</longitud>
			<periode>".parseToXML($row_periodes['periode'])."</periode><epoca>".parseToXML($row_periodes['epoca'])."</epoca>
			<imatges>";
		$sql_imatges = mysql_query("SELECT * FROM imatges WHERE id_jaciment=".$row_jacimentsxperiode['id_jaciment']." AND id_periode=".$row_periodes['id_periode']."");
		while($row_imatges = mysql_fetch_array($sql_imatges)) {
			echo "<imatge>".parseToXML($row_imatges['imatge'])."</imatge><descripcio>".parseToXML($row_imatges['descripcio'])."</descripcio>";
		}
		mysql_free_result($sql_imatges);
		echo "</imatges><documents>";
		$sql_documents = mysql_query("SELECT * FROM documents WHERE id_jaciment=".$row_jacimentsxperiode['id_jaciment']." AND id_periode=".$row_periodes['id_periode']."");
		while($row_documents = mysql_fetch_array($sql_documents)) {
			echo "<document>".parseToXML($row_documents['document'])."</document><descripcio>".parseToXML($row_documents['descripcio'])."</descripcio>";
		}
		mysql_free_result($sql_documents);
	echo "</documents></jaciment>";
	}
	echo "</llistatJaciments>";
	mysql_free_result($sql_jacimentsxperiode);
}

?>


