/* Funci per crear l'objecte XMLHTTPRequest que permet la connexi amb el servidor web */
/* i obtenir dades d'aquest de forma asncrona.                                         */
function getXMLHTTPRequest() {
   var req =  false;
   try {
      /* Si el navegador s Firefox */
      req = new XMLHttpRequest(); 
   } catch (err) {
      try {
         /* Per algunes versions d'Internet Explorer */
         req = new ActiveXObject("Msxml2.XMLHTTP");
      } catch (err) {
         try {
            /* Per altres versions d'Internet Explorer */
            req = new ActiveXObject("Microsoft.XMLHTTP");
         } catch (err) {
            req = false;
         }
     }
   }
   return req;
}

/* Funci que recull el valor del perode seleccionat i que l'objecte 'myReq' empra per */
/* passar-li al codi del fitxer 'llistarjaciments.php' al qual invoca.                  */
function llistarJaciments(periode) {
  var thePage = 'llistarjaciments.php';
  var theURL = thePage +"?periode="+periode;
  myReq.open("GET", theURL, true);
  myReq.onreadystatechange = theHTTPResponse;
  myReq.send(null);
}

/* Funci per a que l'objecte 'myReq' invoqui el codi del fitxer 'mostrarmuseu.php'.    */
function mostrarMuseu() {
  myReq.open("GET", 'mostrarmuseu.php', true);
  myReq.onreadystatechange = theHTTPResponse;
  myReq.send(null);
}

/* Funci per recollir les dades de la resposta del servidor que es troben en format    */
/* XML dins l'objecte 'myReq'.                                                          */
/* S'esperen 2 tipus de resposta que es diferencien segons el valor de la variable      */
/* 'ajax_function'. Si val 1 cont les dades dels jaciments. Si val 2, les del museu.   */
function theHTTPResponse() {
  if (myReq.readyState == 4) {
    if(myReq.status == 200) {      
	if(ajax_function == 1) {  

/* Es netegen el mapa i la capa 'dadesjaciment' de qualsevol jaciment anterior.         */
		noMostrarJacimentsEnMapa();
		document.getElementById('dadesjaciment').innerHTML = "";
		
/* Per cada jaciment, s'afegeixen les seves dades a la capa 'dadesjaciment' i s'omplen   */
/* els vectors 'imatges_imatge' i 'documents_document' amb les seves imatges i documents.*/		
		for (i = 0; i < myReq.responseXML.getElementsByTagName("nom").length; i++){ 
			document.getElementById('dadesjaciment').innerHTML = document.getElementById('dadesjaciment').innerHTML + String.fromCharCode("A".charCodeAt(0)+i) + ": " + myReq.responseXML.getElementsByTagName("nom")[i].childNodes[0].nodeValue + " - " + myReq.responseXML.getElementsByTagName("ubicacio")[i].childNodes[0].nodeValue + "<br>&nbsp;&nbsp;&nbsp;&nbsp;[Lat: " + myReq.responseXML.getElementsByTagName("latitud")[i].childNodes[0].nodeValue + " - Lon: " + myReq.responseXML.getElementsByTagName("longitud")[i].childNodes[0].nodeValue + "]<br>&nbsp;&nbsp;&nbsp;&nbsp;" + myReq.responseXML.getElementsByTagName("periode")[i].childNodes[0].nodeValue + " - " + myReq.responseXML.getElementsByTagName("epoca")[i].childNodes[0].nodeValue;
			var imatges = myReq.responseXML.getElementsByTagName("imatges")[i];
			var imatges_imatge = new Array();
			var imatges_descripcio = new Array();
			for (j = 0; j < imatges.getElementsByTagName("imatge").length; j++){ 
				imatges_imatge.push(imatges.getElementsByTagName('imatge')[j].childNodes[0].nodeValue);
				imatges_descripcio.push(imatges.getElementsByTagName('descripcio')[j].childNodes[0].nodeValue);
			}			
			var documents = myReq.responseXML.getElementsByTagName("documents")[i];
			var documents_document = new Array();
			var documents_descripcio = new Array();
			for (j = 0; j < documents.getElementsByTagName("document").length; j++){ 
				documents_document.push(documents.getElementsByTagName('document')[j].childNodes[0].nodeValue);
				documents_descripcio.push(documents.getElementsByTagName('descripcio')[j].childNodes[0].nodeValue);
			}

/* Si el jaciment no s l'ltim s'afegeix un separador a la capa 'dadesjaciment' i es   */
/* mostra aquest al mapa.                                                               */		
			if (i < myReq.responseXML.getElementsByTagName("nom").length -1)
				document.getElementById('dadesjaciment').innerHTML = document.getElementById('dadesjaciment').innerHTML + "<hr>";
			mostrarJacimentEnMapa(i+1, myReq.responseXML.getElementsByTagName("nom")[i].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("ubicacio")[i].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("periode")[i].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("epoca")[i].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("latitud")[i].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("longitud")[i].childNodes[0].nodeValue, imatges_imatge, imatges_descripcio, documents_document, documents_descripcio);
		}     
    }
	if(ajax_function == 2) {  
		mostrarMuseuEnMapa(myReq.responseXML.getElementsByTagName("nom")[0].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("ubicacio")[0].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("municipi")[0].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("telefon")[0].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("planol")[0].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("latitud")[0].childNodes[0].nodeValue, myReq.responseXML.getElementsByTagName("longitud")[0].childNodes[0].nodeValue);
        }
    }
  } 
}
